'MORPRA1.BAS
'INDFMT(2,32)
'Uses the PC speaker to create the sounds of a Morse Code Transmission.
'Generates a random message (garbage really) and beeps to practice receiving.
' The practice message is short and simple.  A good starting point for novices.
'Timing of the silent pauses are set to the rather SLOW for novice learners.
'                  Written by Edwin M. Kiser  03/17/2003

'Practice receiving MORSE code.

'Feel free to distribute to anyone that may be interested.

DEFINT I                       'all variables beginning with "i" are INTEGER
DEFSTR S                       'all variables beginning with "s" are STRING

CLS                            'start with the screen CLEAR SCREEN

'----------------DEFINING WHAT THE RANDOM MESSAGE WILL CONTAIN--------

'THE MESSAGES THEMSELVES ARE JUST RANDOM GARBAGE, NOT INTENDED TO HAVE ANY
' MEANING.  IT IS JUST A DRILL IN SEEING IF YOU CAN RECOGNIZE THE CHARACTERS
' AS THEY ARE SENT.

CONST iWORDS = 5               'num words in message
                               ' originally set to '3'

CONST iLETTERS = 1             'num letters per word
                               ' originally set to '5'

'--------------DEFINING THE SPEED OF THE TRANSMISSION-----------------

'The following two settings may need to be made larger during the learning
' process.  These effect the time of the silence, not the char itself.

CONST iENDCHARVAL = 20         'length of pause after each char
                               ' officially should be 3
                               ' originally set to '20' (rather slow)

CONST iENDWORDVAL = 7         'length of pause after each word
                               ' officially should be 7
                               ' originally set to '30' (very slow)

'The "iT" value below defines how fast each char is sent.  The larger
' the number, the faster is the transmission speed.
'Try several values: 12 for very slow, and 32 (or more) for really fast, with
' other values in between to suit your abilities to receive.

CONST iT = 32                  'sets the timing of rate of transmission
                               ' of each character
                               ' originally set to '24' (medium speed)

'Try to get used to the sound of each character sent as a rather rapid
' sequence of dots and dashes.  The length of the silence
' can be increased to facilitate the learner's time for reaction.
'  (see iENDCHARVAL and iENDWORDVAL above for silence definition)

CONST iMAXGEN = 26             'limits the set of chars to be generated
                               ' originally set to 26 (ALPHA only)

'Possible values for "iMAXGEN" and their meaning:
' 26 - limit msg to alpha chars only
' 30 - add to alpha chars the PERIOD, SPACE, COMMA, QUESTION
' 40 - add to the above list the numerical digits
' 48 - (max setting) allows generation of all the supported chars (see sALPHA)

'THE ABOVE CONSTANTS:
'  iWORDS, iLETTERS, iT, iENDCHARVAL, iENDWORDVAL, and iMAXGEN,
'ARE THE ONLY VALUES YOU SHOULD PLAY AROUND WITH.

'LEAVE THE REST OF THIS STUFF ALONE, AS IT (hopefully) WORKS FINE AS IS.
'EXPERIMENT WITH THESE CONSTANT SETTINGS AND SEE THE RESULTS.
'SET IT UP TO MATCH YOUR OWN LEVEL OF SKILL.

'-------------TRANSMISSION SPEED NOW DEFINED--------------------------

'Timing is done through the use of the PLAY command that allows for
' the specification of the length of each note to be played.  The
' PLAY command also allows for the playing of a SILENT note to give
' the effect of a pause between parts of the audible transmission.

'The DOT and DASH is done by the playing of a single note, the tone
' of which is determined by sPITCH (below), with the length of that
' note being used to distinguish DOT from DASH.

'In preparation for using the PLAY command, we set up certain
' parameters to be handed to PLAY:

sTRT = STR$(iT)                'define time for dot
iTT = iT \ 3                   'define time for dash
                               ' the time of the DASH is supposed
                               ' to be THREE times that of the DOT
sTRTT = STR$(iTT)

'get these time delay values into a command string format suitable
' to be passed to the PLAY function:

sDOTTIME = "L" + RIGHT$(sTRT, LEN(sTRT) - 1)
sDASHTIME = "L" + RIGHT$(sTRTT, LEN(sTRTT) - 1)

sPITCH = "C"                   'pitch of tone generated (in range A-G)
sQUIET = "N0"                  'the SILENT note

'--------------PARAMETERS TO BE PASSED TO "PLAY" NOW SET-------------

sQUOTE = CHR$(34)              'double quote ( " ) character
sALPHA = "ABCDEFGHIJKLMNOPQRSTUVWXYZ. ,?0123456789:-`'/()" + sQUOTE'supported characters
'                  1         2         3         4
'         12345678901234567890123456789012345678901234567

RANDOMIZE (TIMER)
DO
: CLS                          'start with a fresh screen
: sL = ""                      'clear text to start fresh
: FOR iWORD = iWORDS TO 1 STEP -1'generate this many words
: : FOR iLETTER = iLETTERS TO 1 STEP -1'randomly invent a "word"
: : : sL = sL + MID$(sALPHA, INT(RND * iMAXGEN) + 1, 1)'add char to "word"
: : NEXT iLETTER               'go back and add another char to "word"

: : IF iWORD > 1 THEN          'if there is still another word
: : : sL = sL + " "            'put a space between words
: : END IF

: NEXT iWORD
: PRINT "Listen carefully, and write down this message..."

: PRINT "Press any key to continue"'give time to get paper and pencil ready
: DO WHILE INKEY$ = ""         'wait here for any keystroke
: LOOP

: DO
    GOSUB SPACHAR              'PAUSE FOR "END OF WORD" TIME
: : PRINT                      'start a new line
: : FOR I = 1 TO LEN(sL)       'step thru each char of message
: : : sCHAR = MID$(sL, I, 1)   'get next char from msg
: : : iPTR = INSTR(sALPHA, sCHAR)'translate char to ordinal position
: : : IF iPTR THEN             'if char is in supported listing
: : : : ON iPTR GOSUB A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S, T, U, V, W, X, Y, Z, PERIOD, SPACHAR, COMMA, QUESTION, ZERO, ONE, TWO, THREE, FOUR, FIVE, SIX, SEVEN, EIGHT, NINE, CO, HY, AP, AP, SLASH, PA, PA, QU
: : : : GOSUB ENDCHAR          'terminate char with some silence
: : : END IF

: : NEXT I                     'go do next char from msg
: : PRINT                      'finished with msg, get new line
: : PRINT "Hit just ENTER to repeat this msg, or"
: : PRINT "Hit any char then ENTER to generate new message, or"
: : PRINT "* then Enter to QUIT: "
: : LINE INPUT sAGAIN          'read operator's reply

: LOOP WHILE LEN(sAGAIN) = 0   'if just ENTER, repeat msg

: PRINT sL                     'display this message text for comparison
: PRINT "Press any key to continue"'give time to study results
: DO WHILE INKEY$ = ""         'wait here for any keystroke
: LOOP

: IF LEFT$(sAGAIN, 1) = "*" THEN 'if * found, quit
: : EXIT DO
: END IF
LOOP
CLS
SYSTEM                         'return to operating system

'----------------------------------
A:                             '.-
GOSUB DOT: GOSUB DASH
RETURN

B:                             '-...
GOSUB DASH: GOSUB DOT: GOSUB DOT: GOSUB DOT
RETURN

C:                             '-.-.
GOSUB DASH: GOSUB DOT: GOSUB DASH: GOSUB DOT
RETURN

D:                             '-..
GOSUB DASH: GOSUB DOT: GOSUB DOT
RETURN

E:                             '.
GOSUB DOT
RETURN

F:                             '..-.
GOSUB DOT: GOSUB DOT: GOSUB DASH: GOSUB DOT
RETURN

G:                             '--.
GOSUB DASH: GOSUB DASH: GOSUB DOT
RETURN

H:                             '....
GOSUB DOT: GOSUB DOT: GOSUB DOT: GOSUB DOT
RETURN

I:                             '..
GOSUB DOT: GOSUB DOT
RETURN

J:                             '.---
GOSUB DOT: GOSUB DASH: GOSUB DASH: GOSUB DASH
RETURN

K:                             '-.-
GOSUB DASH: GOSUB DOT: GOSUB DASH
RETURN

L:                             '.-..
GOSUB DOT: GOSUB DASH: GOSUB DOT: GOSUB DOT
RETURN

M:                             '--
GOSUB DASH: GOSUB DASH
RETURN

N:                             '-.
GOSUB DASH: GOSUB DOT
RETURN

O:                             '---
GOSUB DASH: GOSUB DASH: GOSUB DASH
RETURN

P:                             '.--.
GOSUB DOT: GOSUB DASH: GOSUB DASH: GOSUB DOT
RETURN

Q:                             '--.-
GOSUB DASH: GOSUB DASH: GOSUB DOT: GOSUB DASH
RETURN

R:                             '.-.
GOSUB DOT: GOSUB DASH: GOSUB DOT
RETURN

S:                             '...
GOSUB DOT: GOSUB DOT: GOSUB DOT
RETURN

T:                             '-
GOSUB DASH
RETURN

U:                             '..-
GOSUB DOT: GOSUB DOT: GOSUB DASH
RETURN

V:                             '...-
GOSUB DOT: GOSUB DOT: GOSUB DOT: GOSUB DASH
RETURN

W:                             '.--
GOSUB DOT: GOSUB DASH: GOSUB DASH
RETURN

X:                             '-..-
GOSUB DASH: GOSUB DOT: GOSUB DOT: GOSUB DASH
RETURN

Y:                             '-.--
GOSUB DASH: GOSUB DOT: GOSUB DASH: GOSUB DASH
RETURN

Z:                             '--..
GOSUB DASH: GOSUB DASH: GOSUB DOT: GOSUB DOT
RETURN

PERIOD:                        '.-.-.- (in the UK, called "full stop")
GOSUB DOT: GOSUB DASH: GOSUB DOT: GOSUB DASH: GOSUB DOT: GOSUB DASH
RETURN

SPACHAR:                       'END OF WORD-delay
FOR iREPEAT = 1 TO iENDWORDVAL
: GOSUB PAUSE
NEXT iREPEAT
RETURN

COMMA:                         '--..--
GOSUB DASH: GOSUB DASH: GOSUB DOT: GOSUB DOT: GOSUB DASH: GOSUB DASH
RETURN

QUESTION:                      '..--..
GOSUB DOT: GOSUB DOT: GOSUB DASH: GOSUB DASH: GOSUB DOT: GOSUB DOT
RETURN

ZERO:                          '-----
GOSUB DASH: GOSUB DASH: GOSUB DASH: GOSUB DASH: GOSUB DASH
RETURN

ONE:                           '.----
GOSUB DOT: GOSUB DASH: GOSUB DASH: GOSUB DASH: GOSUB DASH
RETURN

TWO:                           '..---
GOSUB DOT: GOSUB DOT: GOSUB DASH: GOSUB DASH: GOSUB DASH
RETURN

THREE:                         '...--
GOSUB DOT: GOSUB DOT: GOSUB DOT: GOSUB DASH: GOSUB DASH
RETURN

FOUR:                          '....-
GOSUB DOT: GOSUB DOT: GOSUB DOT: GOSUB DOT: GOSUB DASH
RETURN

FIVE:                          '.....
GOSUB DOT: GOSUB DOT: GOSUB DOT: GOSUB DOT: GOSUB DOT
RETURN

SIX:                           '-....
GOSUB DASH: GOSUB DOT: GOSUB DOT: GOSUB DOT: GOSUB DOT
RETURN

SEVEN:                         '--...
GOSUB DASH: GOSUB DASH: GOSUB DOT: GOSUB DOT: GOSUB DOT:
RETURN

EIGHT:                         '---..
GOSUB DASH: GOSUB DASH: GOSUB DASH: GOSUB DOT: GOSUB DOT:
RETURN

NINE:                          '----.
GOSUB DASH: GOSUB DASH: GOSUB DASH: GOSUB DASH: GOSUB DOT
RETURN

CO:                            '---... (COLON)
GOSUB DASH: GOSUB DASH: GOSUB DASH: GOSUB DOT: GOSUB DOT: GOSUB DOT
RETURN

HY:                            '-....- (HYPHEN)
GOSUB DASH: GOSUB DOT: GOSUB DOT: GOSUB DOT: GOSUB DOT: GOSUB DASH
RETURN

AP:                            '.----. (APOSTROPHE)
GOSUB DOT: GOSUB DASH: GOSUB DASH: GOSUB DASH: GOSUB DASH: GOSUB DOT
RETURN

SLASH:                         '-..-. (SLASH)
GOSUB DASH: GOSUB DOT: GOSUB DOT: GOSUB DASH: GOSUB DOT
RETURN

PA:                            '-.--.- (PARENTHESIS - EITHER ONE)
GOSUB DASH: GOSUB DOT: GOSUB DASH: GOSUB DASH: GOSUB DOT: GOSUB DASH
RETURN

QU:                            '.-..-. (DOUBLE QUOTE)
GOSUB DOT: GOSUB DASH: GOSUB DOT: GOSUB DOT: GOSUB DASH: GOSUB DOT
RETURN

'--------------------------------
'In this next section, we drive the PLAY command to use the PC speaker
' to generate both the sounds and the silent pauses between sounds
' to emulate the effect of sending audible MORSE CODE.
'Each PLAY command has two parms: the TIMING, and the NOTE.
'The timing is defined as either "sDOTTIME" or "sDASHTIME".
'The NOTE is either the audible "sPITCH" or the pause "sQUIET".

DOT:
PLAY sDOTTIME + sPITCH         'generate s SHORT sound
FOR iREPEAT = 1 TO 2
: GOSUB PAUSE
NEXT iREPEAT
RETURN

DASH:
PLAY sDASHTIME + sPITCH        'generate a LONG sound
FOR iREPEAT = 1 TO 1
: GOSUB PAUSE
NEXT iREPEAT
RETURN

ENDCHAR:                       'END OF CHAR-delay
FOR iREPEAT = 1 TO iENDCHARVAL
: GOSUB PAUSE
NEXT iREPEAT
RETURN

PAUSE:                         'the pause after a DOT or DASH
PLAY sDOTTIME + sQUIET         'the SILENT note
RETURN
'-------------END OF PROGRAM - MORPRACT.BAS---------------------

